package org.jabricks.basegui.examples;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.*;

import org.jabricks.basegui.grid.Grid;
import org.jabricks.basegui.grid.IGrid;

public class ExampleGridCheck extends JFrame
{
	private static final long serialVersionUID = 1L;
	
	private  IGrid   grid;
	
	private  Object[][] data = {{"Йогурт" , 0.5f, false},
			                    {"Молоко" , 0.9f, false},
			                    {"Кефир"  , 0.5f, false},
			                    {"Ряженка", 0.5f, true }};
	private  Class<?>[] classes       = {String.class  , 
			                             Float.class   , 
			                             Boolean.class};
	private  String  [] columnsTitle  = {"Наименование",
			                             "Количество"  , 
			                             "Выбор"      };
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	public ExampleGridCheck()
	{
		super("Grid width CheckBox");
		setDefaultCloseOperation(EXIT_ON_CLOSE);
 
		// Создание таблицы
        createGrid();

		Container cp =  getContentPane();
		cp.add(grid.asWidget(), BorderLayout.CENTER);
		cp.add(createButton(), BorderLayout.SOUTH );

		setSize(440, 360);

		// Загрузка данных
		grid.addRecords(data);

		setVisible(true);
	}
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	private void createGrid()
	{
		grid = new Grid(classes, columnsTitle, columnsTitle);

		grid.addCheckBoxEditor(2);
		grid.setReorderingAllowed(false);
		grid.setColumnsWidth(new int[] {220, 90, 90});
	}
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	private JPanel createButton()
	{
		JButton btnChooser = new JButton("Выбрать записи");
		btnChooser.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				ChoosedRows();
			}
		});
		// Панель с кнопкой
		JPanel pnlButtons = new JPanel();
		pnlButtons.add(btnChooser);
		return pnlButtons;
	}
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	private void ChoosedRows()
	{
		// Выбранные строки
		int[] rows = grid.getCheckedRows();
		String msg = "";
		for (int i = 0; i < rows.length; i++) {
			if (msg.length() > 0)
				msg += ", ";
			msg += String.valueOf(rows[i]);
//			System.out.println("" + rows[i]);
		}
		String title = "Выделенные строки"; 
		if (msg.length() > 0) {
			msg = "Вы выбрали следующие строки : " + msg;
			showMessage (msg);
		} else
			showMessage ("Вы не выбрали ни одной строки");
	}
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	private void showMessage (final String msg)
	{
        String title = "Выделенные строки"; 
        JOptionPane.showMessageDialog(ExampleGridCheck.this,
                                      msg, title, 
                           JOptionPane.INFORMATION_MESSAGE);
	}
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
/*
	public static void main(String[] args)
	{
		new ExampleGridCheck();
	}
*/
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
};