package org.jabricks.basegui.examples;

import java.awt.Color;
import java.awt.Component;

import javax.swing.JLabel;
import javax.swing.JTable;
import javax.swing.JLabel;
import javax.swing.UIManager;
import javax.swing.border.Border;
import javax.swing.border.LineBorder;
import javax.swing.table.TableCellRenderer;

public class IntegerRenderer extends JLabel implements TableCellRenderer  
{
    private static final long serialVersionUID = 1L;
    Color   COLOR_selectionBackground = UIManager.getColor("Table.selectionBackground");  
	Border  BORDER_selected           = new LineBorder(new Color(142, 169, 204));

  @Override
  public Component getTableCellRendererComponent(JTable table, Object value, 
                                                 boolean isSelected, 
                                                 boolean hasFocus, 
                                                 int row,  int column) {
	  setFont(table.getFont());

	  setOpaque(true);
	  setBackground(Color.white);
	  if(isSelected)
		  setBackground(COLOR_selectionBackground);
	  if (hasFocus)
		  setBorder(BORDER_selected);
	  else
		  setBorder(new LineBorder(null, 0));

	  if (value != null) {
		  if ((Integer)value < 0) {
			  setForeground(Color.red);
		  } else
			  setForeground(Color.black);
	  }
	  setHorizontalAlignment(JLabel.RIGHT);
	  if (value == null)
		  setText("");
	  else
		  setText(String.valueOf(value) + " ");
	  return this;
  	}
}
