package org.jabricks.basegui.examples;

import java.util.List;
import java.util.ArrayList;

public class ModuleDAO
{
	private final int COL_ID = 4;
	private Object[][] data = 
                  {{ "Мороженое"     ,   5,  80,  400},
                   { "Пироженое"     ,  10,  45,  450},
                   { "Слива"         ,   2,  80,  160},
                   { "Виноград"      ,   3,  75,  225},
                   { "Байкал 1.0"    ,  10,  39,  390},
                   { "Coca-cola 1.5" ,   5,  60,  300},
                   { "Coca-cola 2.0" ,   5,  78,  390},
                   { "Яблоки"        ,   4,  60,  240},
                   { "Абрикосы"      ,   2,  90,  180},
                   { "Бананы"        ,   1,  60,   60},
 			       { "Молоко 0.9"    ,   2,  55,  110},
 			       { "Кефир 0.5"     ,   2,  55,  110},
 			       { "Ряженка 0.5"   ,   2,  45,   90}};

	private List<Object[]> records; // набор записей
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	public ModuleDAO()
	{
		records = new ArrayList<Object[]>();
		for (int i = 0; i < data.length; i++) {
			Object[] obj = new Object[COL_ID + 1];
			for (int j = 0; j < data[i].length; j++)
				obj[j] = data[i][j];
			obj[COL_ID] = (i + 1); // ID записи
			records.add(obj);
		}
	}	
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	/**
	 * Метод чтения записей
	 */
	public Object[][] loadData(final int offs, final int limit)
	{
        int size = limit;
		if ((records.size() - offs) < limit)
		    size = records.size() - offs;
		Object[][] objects = new Object[size][COL_ID + 1];
		for (int i = offs; i < records.size(); i++) {
			Object[] obj = records.get(i);
			for (int j = 0; j < obj.length; j++)
				objects[i - offs][j] = obj[j];
			if ((i - offs) == (limit - 1))
				break;
		}
        return objects;
	}
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	public int getRecordsCount()
	{
		return records.size();
	}
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	private int getMaxID()
	{
		int id = 0;
		for (int i = 0; i < records.size(); i++) {
			Object[] obj = records.get(i);
			if ((int) obj[COL_ID] > id)
				id = (int) obj[COL_ID];
		}
	return id + 1;
	}
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	/**
	 * Процедура добавления записи
	 * Новая запись добавляется в коллекцию records
	 */
	public Object[] addRecord(Object[] record)
	{
		Object[] obj = new Object[data[0].length + 1];
		for (int i = 0; i < data[0].length; i++)
			obj[i] = record[i];
		obj[COL_ID] = getMaxID();
		records.add(obj);
		
		return obj;
	}
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	/*
	 * Процедура отладки удаления записи из таблицы
	 */
	public void deleteRecord(final int id)
	{
		for (int i = 0; i < records.size(); i++) {
			Object[] obj = records.get(i);
			if ((int) obj[COL_ID] == id) {
				records.remove(i);
				break;
			}
		}
	}
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
}